// **********************************************
// MongoDB library
// **********************************************
using System;
using System.Text;
using System.Collections;
using com.progamma;
using com.progamma.doc;
using MongoDB.Bson;
using MongoDB.Driver;

public class MongoLib
{
  public static bool LoadDocument(com.progamma.ids.WebEntryPoint MainFrm, IDCollection coll, IDDocument doc)
  {
    coll.Clear();
    //
    MongoClient cli = new MongoClient("mongodb://localhost");
    MongoServer srv = cli.GetServer();
    MongoDatabase db = srv.GetDatabase("tempdb");
    //
    DOMDObj md = doc.GetMD();
    MongoCollection dbcoll = db.GetCollection(md.ObjTag);
    //
    // Se ci sono criteri QBE, li applico
    MongoCursor cur = null;
    //    if (!doc.IsEmpty())
    //      cur = dbcoll.FindAs(typeof(BsonDocument), qry);
    //    else
    cur = dbcoll.FindAllAs(typeof(BsonDocument));
    //
    foreach (BsonDocument d in cur)
    {
      IDDocument newdoc = MainFrm.CreateDocument(md.ObjTag);
      coll.Add(newdoc);
      //
      foreach (BsonElement el in d.Elements)
      {
        int pidx = newdoc.GetPropertyIndex(el.Name, false, false, false, true);
        if (pidx > 0)
          newdoc.SetPropByIndex(pidx, IDVariant.convertObject(el.Value.RawValue));
      }
    }
    coll.SetOriginal();
    //
    return true;
  }

  public static bool SaveDocument(com.progamma.ids.WebEntryPoint MainFrm, IDDocument doc, IDVariant Oper)
  {
    MongoClient cli = new MongoClient("mongodb://localhost");
    MongoServer srv = cli.GetServer();
    MongoDatabase db = srv.GetDatabase("tempdb");
    //
    DOMDObj md = doc.GetMD();
    MongoCollection dbcoll = db.GetCollection(md.ObjTag);
    //
    BsonDocument json = new BsonDocument();
    for (int i = 1; i <= md.GetNumProp(); i++)
    {
      DOMDProp p = md.GetProp(i);
      IDVariant v = doc.GetPropByIndex(i);
      //
      json.Add(p.ObjTag, BsonValue.Create(v.Value));
    }
    //
    switch (Oper.intValue())
    {
      case 1: dbcoll.Insert(json); break;

      case 2: dbcoll.Save(json); break;

      case 3:
        QueryDocument qry = new QueryDocument();
        int giro = 0;
        while (giro < 2)
        {
          for (int i = 1; i <= md.GetNumProp(); i++)
          {
            DOMDProp mdp = md.GetProp(i);
            IDVariant v = doc.GetPropByIndex(i);
            //
            if (mdp.PK || "DO_ID".Equals(mdp.Concept) || giro == 1)
              qry.Add(mdp.ObjTag, BsonValue.Create(v.Value));
          }
          //
          if (qry.ElementCount > 0)
            break;
          //
          giro++;
        }
        dbcoll.Remove(qry, RemoveFlags.Single);
        break;

    }
    //
    return false;
  }
}
